<?php
/**
 * ESTES Test connection
 *
 * @package     ESTES Freight Quotes
 * @author      Eniture-Technology
 */
if (!defined('ABSPATH')) {
    exit;
}

add_action('wp_ajax_nopriv_estes_test_connection', 'estes_test_submit');
add_action('wp_ajax_estes_test_connection', 'estes_test_submit');
/**
 * Estes Test connection AJAX Request
 */
function estes_test_submit()
{
    $data = array(
        'CUSTNMBR' => (isset($_POST['estes_custom_no'])) ? sanitize_text_field($_POST['estes_custom_no']) : "",
        'UserName' => (isset($_POST['estes_username'])) ? sanitize_text_field($_POST['estes_username']) : "",
        'Password' => (isset($_POST['estes_password'])) ? sanitize_text_field($_POST['estes_password']) : "",
        'licence_key' => (isset($_POST['estes_license'])) ? sanitize_text_field($_POST['estes_license']) : "",
        'sever_name' => estes_freight_get_domain(),
        'carrierName' => 'estes',
        'plateform' => 'WordPress',
        'carrier_mode' => 'test'
    );

    $estes_curl_obj = new ESTES_Curl_Request();
    $response_data = $estes_curl_obj->estes_get_curl_response(ESTES_FREIGHT_DOMAIN_HITTING_URL . '/index.php', $data);
    $response_data = json_decode($response_data, true);

    if (isset($response_data['q']['soapenvBody']['ratrateQuote'])) {
        $sResult = array('message' => "success");
    } elseif (isset($response_data['error']) && is_string($response_data['error']) && strlen($response_data['error']) > 0) {
        $sResult = array('message' => $response_data['error']);
    } elseif (isset($response_data['error'], $response_data['error']['0']) && is_string($response_data['error']['0']) && ($response_data['error']['0'] != 'Schema validation error' && $response_data['error']['0'] != 'GeneralErrorMsg')) {
        $sResult = $response_data['error']['0'];
        $sResult = ['message' => $sResult];
    } else {
        $sResult = ['message' => "failure"];
    }

    echo json_encode($sResult);
    exit();
}
