<?php

/**
 * ESTES Quotes Setting
 *
 * @package     ESTES Freight Quotes
 * @author      Eniture-Technology
 */
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Class For Quote Settings Tab
 */
class ESTES_Quote_Settings
{

    /**
     * Quote Setting Fields
     * @return array
     */
    function estes_quote_settings_tab()
    {
        $disable_hold_at_terminal = "";
        $hold_at_terminal_package_required = "";

        $action_hold_at_terminal = apply_filters('estes_ltl_quotes_quotes_plans_suscription_and_features', 'estes_freight_hold_at_terminal');

        if (is_array($action_hold_at_terminal)) {
            $disable_hold_at_terminal = "disabled_me";
            $hold_at_terminal_package_required = apply_filters('estes_ltl_quotes_plans_notification_link', $action_hold_at_terminal);
        }

        // Cuttoff Time
        $estes_disable_cutt_off_time_ship_date_offset = "";
        $estes_cutt_off_time_package_required = "";

        //  Check the cutt of time & offset days plans for disable input fields
        $estes_action_cutOffTime_shipDateOffset = apply_filters('estes_ltl_quotes_quotes_plans_suscription_and_features', 'estes_cutt_off_time');
        if (is_array($estes_action_cutOffTime_shipDateOffset)) {
            $estes_disable_cutt_off_time_ship_date_offset = "disabled_me";
            $estes_cutt_off_time_package_required = apply_filters('estes_ltl_quotes_plans_notification_link', $estes_action_cutOffTime_shipDateOffset);
        }

        $ltl_enable = get_option('en_plugins_return_LTL_quotes');
        $weight_threshold_class = $ltl_enable == 'yes' ? 'show_en_weight_threshold_lfq' : 'hide_en_weight_threshold_lfq';
        $weight_threshold = get_option('en_weight_threshold_lfq');
        $weight_threshold = isset($weight_threshold) && $weight_threshold > 0 ? $weight_threshold : 150;

        echo '<div class="estes_quote_section">';
        $settings = array(
            'section_title_quote' => array(
                'title' => __('', 'estes_wc_settings'),
                'type' => 'title',
                'desc' => '<br> ',
                'id' => 'estes_section_title'
            ),
            'estes_label_as' => array(
                'name' => __('Label As ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => '<span class="desc_text_style">What the user sees during checkout, e.g. "LTL Freight". If left blank, "Freight" will display as the shipping method.</span>',
                'id' => 'estes_setting_label_as'
            ),
            'price_sort_estes' => array(
                'name' => __("Don't sort shipping methods by price  ", 'woocommerce-settings-abf_quotes'),
                'type' => 'checkbox',
                'desc' => 'By default, the plugin will sort all shipping methods by price in ascending order.',
                'id' => 'shipping_methods_do_not_sort_by_price'
            ),
            //** Start Delivery Estimate Options - Cuttoff Time
            'service_estes_estimates_title' => array(
                'name' => __('Delivery Estimate Options ', 'woocommerce-settings-en_woo_addons_packages_quotes'),
                'type' => 'text',
                'desc' => '',
                'id' => 'service_estes_estimates_title'
            ),
            'estes_show_delivery_estimates_options_radio' => array(
                'name' => __("", 'woocommerce-settings-estes'),
                'type' => 'radio',
                'default' => 'dont_show_estimates',
                'options' => array(
                    'dont_show_estimates' => __("Don't display delivery estimates.", 'woocommerce'),
                    'delivery_days' => __("Display estimated number of days until delivery.", 'woocommerce'),
                    'delivery_date' => __("Display estimated delivery date.", 'woocommerce'),
                ),
                'id' => 'estes_delivery_estimates',
                'class' => 'estes_dont_show_estimate_option',
            ),
            //** End Delivery Estimate Options
            //**Start: Cut Off Time & Ship Date Offset
            'cutOffTime_shipDateOffset_estes_freight' => array(
                'name' => __('Cut Off Time & Ship Date Offset ', 'woocommerce-settings-en_woo_addons_packages_quotes'),
                'type' => 'text',
                'class' => 'hidden',
                'desc' => $estes_cutt_off_time_package_required,
                'id' => 'estes_freight_cutt_off_time_ship_date_offset'
            ),
            'orderCutoffTime_estes_freight' => array(
                'name' => __('Order Cut Off Time ', 'woocommerce-settings-estes_freight_freight_orderCutoffTime'),
                'type' => 'text',
                'placeholder' => '-- : -- --',
                'desc' => 'Enter the cut off time (e.g. 2.00) for the orders. Orders placed after this time will be quoted as shipping the next business day.',
                'id' => 'estes_freight_order_cut_off_time',
                'class' => $estes_disable_cutt_off_time_ship_date_offset,
            ),
            'shipmentOffsetDays_estes_freight' => array(
                'name' => __('Fullfillment Offset Days ', 'woocommerce-settings-estes_freight_shipment_offset_days'),
                'type' => 'text',
                'desc' => 'The number of days the ship date needs to be moved to allow the processing of the order.',
                'placeholder' => 'Fullfillment Offset Days, e.g. 2',
                'id' => 'estes_freight_shipment_offset_days',
                'class' => $estes_disable_cutt_off_time_ship_date_offset,
            ),
            'all_shipment_days_estes' => array(
                'name' => __("What days do you ship orders?", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Select All',
                'class' => "all_shipment_days_estes $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'all_shipment_days_estes'
            ),
            'monday_shipment_day_estes' => array(
                'name' => __("", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Monday',
                'class' => "estes_shipment_day $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'monday_shipment_day_estes'
            ),
            'tuesday_shipment_day_estes' => array(
                'name' => __("", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Tuesday',
                'class' => "estes_shipment_day $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'tuesday_shipment_day_estes'
            ),
            'wednesday_shipment_day_estes' => array(
                'name' => __("", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Wednesday',
                'class' => "estes_shipment_day $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'wednesday_shipment_day_estes'
            ),
            'thursday_shipment_day_estes' => array(
                'name' => __("", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Thursday',
                'class' => "estes_shipment_day $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'thursday_shipment_day_estes'
            ),
            'estes_show_delivery_estimates' => array(
                'name' => __("", 'woocommerce-settings-estes_quotes'),
                'type' => 'checkbox',
                'desc' => 'Friday',
                'class' => "estes_shipment_day $estes_disable_cutt_off_time_ship_date_offset",
                'id' => 'friday_shipment_day_estes'
            ),
            //**End: Cut Off Time & Ship Date Offset
            'accessorial_quoted_estes' => array(
                'title' => __('', 'woocommerce'),
                'name' => __('', 'estes_wc_settings'),
                'desc' => '',
                'id' => 'woocommerce_accessorial_quoted_estes',
                'css' => '',
                'default' => '',
                'type' => 'title',
            ),
            'residential_delivery_options_label' => array(
                'name' => __('Residential Delivery', 'woocommerce-settings-wwe_small_packages_quotes'),
                'type' => 'text',
                'class' => 'hidden',
                'id' => 'residential_delivery_options_label'
            ),
            'estes_residential_delivery' => array(
                'name' => __('Always quote as residential delivery ', 'estes_wc_settings'),
                'type' => 'checkbox',
                'desc' => __('', 'estes_wc_settings'),
                'id' => 'estes_setting_residential',
                'class' => 'accessorial_service EstesCheckboxClass acc_res_chek',
            ),
//                      Auto-detect residential addresses notification
            'avaibility_auto_residential' => array(
                'name' => __('Auto-detect residential addresses', 'woocommerce-settings-wwe_small_packages_quotes'),
                'type' => 'text',
                'class' => 'hidden',
                'desc' => "Click <a target='_blank' href='https://eniture.com/woocommerce-residential-address-detection/'>here</a> to add the Residential Address Detection module. (<a target='_blank' href='https://eniture.com/woocommerce-residential-address-detection/#documentation'>Learn more</a>)",
                'id' => 'avaibility_auto_residential'
            ),
            'liftgate_delivery_options_label' => array(
                'name' => __('Lift Gate Delivery ', 'woocommerce-settings-en_woo_addons_packages_quotes'),
                'type' => 'text',
                'class' => 'hidden',
                'id' => 'liftgate_delivery_options_label'
            ),
            'estes_liftgate_delivery' => array(
                'name' => __('Always quote lift gate delivery ', 'estes_wc_settings'),
                'type' => 'checkbox',
                'desc' => __('', 'estes_wc_settings'),
                'id' => 'estes_settings_liftgate',
                'class' => 'accessorial_service EstesCheckboxClass checkbox_fr_add',
            ),
            'estes_ltl_quotes_liftgate_delivery_as_option' => array(
                'name' => __('Offer lift gate delivery as an option ', 'woocommerce-settings-xpo_quotes'),
                'type' => 'checkbox',
                'desc' => __('', 'woocommerce-settings-fedex_freight'),
                'id' => 'estes_ltl_quotes_liftgate_delivery_as_option',
                'class' => 'accessorial_service checkbox_fr_add',
            ),
//                      Use my liftgate notification
            'avaibility_lift_gate' => array(
                'name' => __('Always include lift gate delivery when a residential address is detected', 'woocommerce-settings-wwe_small_packages_quotes'),
                'type' => 'text',
                'class' => 'hidden',
                'desc' => "Click <a target='_blank' href='https://eniture.com/woocommerce-residential-address-detection/'>here</a> to add the Residential Address Detection module. (<a target='_blank' href='https://eniture.com/woocommerce-residential-address-detection/#documentation'>Learn more</a>)",
                'id' => 'avaibility_lift_gate'
            ),
            
            // Start Hot At Terminal
            'estes_freight_hold_at_terminal_checkbox_status' => array(
                'name' => __('Hold At Terminal', 'woocommerce-settings-fedex_small'),
                'type' => 'checkbox',
                'desc' => "Offer Hold At Terminal as an option $hold_at_terminal_package_required",
                'class' => $disable_hold_at_terminal,
                'id' => 'estes_freight_hold_at_terminal_checkbox_status',
            ),
            'estes_freight_hold_at_terminal_fee' => array(
                'name' => __('', 'ground-transit-settings-ground_transit'),
                'type' => 'text',
                'desc' => 'Adjust the price of the Hold At Terminal option.Enter an amount, e.g. 3.75, or a percentage, e.g. 5%.  Leave blank to use the price returned by the carrier.',
                'class' => $disable_hold_at_terminal,
                'id' => 'estes_freight_hold_at_terminal_fee'
            ),
            // End Hot At Terminal
            // Handling Weight
            'estes_label_handling_unit' => array(
                'name' => __('Handling Unit ', 'estes_freight_wc_settings'),
                'type' => 'text',
                'class' => 'hidden',
                'id' => 'estes_label_handling_unit'
            ),
            'estes_freight_handling_weight' => array(
                'name' => __('Weight of Handling Unit  ', 'estes_freight_wc_settings'),
                'type' => 'text',
                'desc' => 'Enter in pounds the weight of your pallet, skid, crate or other type of handling unit.',
                'id' => 'estes_freight_handling_weight'
            ),
            // max Handling Weight
            'estes_freight_maximum_handling_weight' => array(
                'name' => __('Maximum Weight per Handling Unit  ', 'estes_freight_wc_settings'),
                'type' => 'text',
                'desc' => 'Enter in pounds the maximum weight that can be placed on the handling unit.',
                'id' => 'estes_freight_maximum_handling_weight'
            ),
            'estes_handling_fee' => array(
                'name' => __('Handling Fee / Markup ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => '<span class="desc_text_style">Amount excluding tax. Enter an amount, e.g 3.75, or a percentage, e.g, 5%. Leave blank to disable.</span>',
                'id' => 'estes_settings_handling_fee'
            ),
            'en_estes_enable_logs' => array(
                'name' => __("Enable Logs  ", 'woocommerce-settings-fedex_ltl_quotes'),
                'type' => 'checkbox',
                'desc' => 'When checked, the Logs page will contain up to 25 of the most recent transactions.',
                'id' => 'en_estes_enable_logs'
            ),
            'estes_allow_other_plugins' => array(
                'name' => __('Show WooCommerce Shipping Options ', 'estes_wc_settings'),
                'type' => 'select',
                'default' => '3',
                'desc' => __('<span class="desc_text_style">Enabled options on WooCommerce Shipping page are included in quote results.</span>', 'estes_wc_settings'),
                'id' => 'estes_settings_allow_other_plugins',
                'options' => array(
                    'yes' => __('YES', 'YES'),
                    'no' => __('NO', 'NO')
                )
            ),
            'return_estes_quotes' => array(
                'name' => __("Return LTL quotes when an order parcel shipment weight exceeds the weight threshold  ", 'estes_wc_settings'),
                'type' => 'checkbox',
                'desc' => '<span class="desc_text_style">When checked, the LTL Freight Quote will return quotes when an order’s total weight exceeds the weight threshold (the maximum permitted by WWE and UPS), even if none of the products have settings to indicate that it will ship LTL Freight. To increase the accuracy of the returned quote(s), all products should have accurate weights and dimensions. </span>',
                'id' => 'en_plugins_return_LTL_quotes',
                'class' => 'EstesCheckboxClass',
            ),
            // Weight threshold for LTL freight
            'en_weight_threshold_lfq' => [
                'name' => __('Weight threshold for LTL Freight Quotes  ', 'woocommerce-settings-wwe_freight'),
                'type' => 'text',
                'default' => $weight_threshold,
                'class' => $weight_threshold_class,
                'id' => 'en_weight_threshold_lfq'
            ],
            'section_end_quote' => array(
                'type' => 'sectionend',
                'id' => 'estes_settings_quote_section_end'
            )
        );
        return $settings;
    }

}
